//+ft +w360 +h203 +a0.3 -j
//+kf39 +kff570 +ocams

#include "colors.inc"
#include "textures.inc"
#include "woods.inc"
#include "metals.inc"
#include "golds.inc"
#include "chess2.inc"
#include "stones.inc"
#include "pgn.inc"
#include "anim2.pgn.inc"
//#include "env.inc"
#include "lights.inc"

#declare adj_clock=clock*39;
//#declare adj_clock=(clock/3)*39;

#declare frame_start=150+115;
#declare quick=0;

#if (quick)
	#declare T_WhitePiece=texture {
		pigment { rgb 2 }
	}
	#declare T_BlackPiece=texture {
		pigment { red 2 }
	}
	_Table()
	_Board(0)
#else
	#include "env.inc"
	#declare T_WhitePiece=texture {
		T_Chrome_5B
	}
	#declare T_BlackPiece=texture {
		T_Gold_5B
	}
#end

object {
	Pawn
	#declare loc=S_QRP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Pawn
	#declare loc=S_QNP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Pawn
	#declare loc=S_QBP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Pawn
	#declare loc=S_QP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}

object {
	Pawn
	#declare loc=S_KP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Pawn
	#declare loc=S_KBP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Pawn
	#declare loc=S_KNP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Pawn
	#declare loc=S_KRP_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}

object {
	Rook
	#declare loc=S_KR_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Rook
	#declare loc=S_QR_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Knight
	#declare loc=S_KN_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Knight
	#declare loc=S_QN_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Bishop
	#declare loc=S_KB_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Bishop
	#declare loc=S_QB_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	Queen
	#declare loc=S_Q_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
object {
	King
	#declare loc=S_K_White(adj_clock);
	translate loc*8
	texture { T_WhitePiece }
}
//--------------------------------------------------------------------------------
object {
	Pawn
	#declare loc=S_QRP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Pawn
	#declare loc=S_QNP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Pawn
	#declare loc=S_QBP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Pawn
	#declare loc=S_QP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}

object {
	Pawn
	#declare loc=S_KP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Pawn
	#declare loc=S_KBP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Pawn
	#declare loc=S_KNP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Pawn
	#declare loc=S_KRP_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}

object {
	Rook
	#declare loc=S_KR_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Rook
	#declare loc=S_QR_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Knight
	rotate y*180
	#declare loc=S_KN_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Knight
	rotate y*180
	#declare loc=S_QN_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Bishop
	rotate y*180
	#declare loc=S_KB_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Bishop
	rotate y*180
	#declare loc=S_QB_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	Queen
	#declare loc=S_Q_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}
object {
	King
	#declare loc=S_K_Black(adj_clock);
	translate loc*8
	texture { T_BlackPiece }
}

camera {
	location <36, 13, 24>
	right x*(image_width/image_height)
	up y
	angle 60
	look_at S_QR_White(adj_clock)*8+y*6.5
}
